Skip to content

Deployment List.

GET
/api/data/namespaces/system/site/{site}/apis/apps/v1/namespaces/{namespace}/deployments
curl --request GET \
--url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/data/namespaces/system/site/example/apis/apps/v1/namespaces/example/deployments \
--header 'Authorization: <Authorization>'

API to GET list of deployments for a given namespace in a site.

Examples of this operation.

site
required
string

Site Site name.

namespace
required
string

Namespace Namespace to scope the listing of deployments in a site.

A successful response.

Media typeapplication/json

DeploymentList is a list of Deployments.

object
items

Items is the list of Deployments.

Array<object>

Deployment enables declarative updates for Pods and ReplicaSets.

object
metadata
object
annotations
Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations +optional

Additional metadata and notes

object
clusterName
The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request. +optional

Cluster or grouping configuration

string
<= 1024 characters
creationTimestamp
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
deletionGracePeriodSeconds
Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. Only set when deletionTimestamp is also set. May only be shortened. Read-only. +optional

Security-related configuration

string format: int64
<= 1024 characters
deletionTimestamp
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
finalizers
Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed. Finalizers may be processed and removed in any order. Order is NOT enforced because it introduces significant risk of stuck finalizers. finalizers is a shared field, any actor with permission can reorder it. If the finalizer list is processed in order, then this can lead to a situation in which the component responsible for the first finalizer in the list is waiting for a signal (field value, external system, or other) produced by a component responsible for a finalizer later in the list, resulting in a deadlock. Without enforced ordering finalizers are free to order amongst themselves and are not vulnerable to ordering changes in the list. +optional +patchStrategy=merge

Configuration parameter for finalizers

Array<string>
generateName

GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.

If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).

Applied only if Name is not specified. More info: HTTPS://git.K8s.I/O/community/contributors/devel/sig-architecture/api-conventions.md#idempotency +optional.

string
<= 1024 characters
generation
A sequence number representing a specific generation of the desired state. Populated by the system. Read-only. +optional

Configuration parameter for generation

string format: int64
<= 1024 characters
labels
Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels +optional

Key-value labels for organization and selection

object
managedFields

ManagedFields maps workflow-ID and version to the set of fields that are managed by that workflow. This is mostly for internal housekeeping, and users typically shouldn’t need to set or understand this field. A workflow can be the user’s name, a controller’s name, or the name of a specific apply path like “ci-cd”. The set of fields is always in the version that the workflow used when modifying the object.

+optional.

Array<object>

ManagedFieldsEntry is a workflow-ID, a FieldSet and the group version of the resource that the fieldset applies to.

object
apiVersion

APIVersion defines the version of this resource that this field set applies to. The format is “group/version” just like the top-level APIVersion field. It is necessary to track the version of a field set because it cannot be automatically converted.

string
<= 1024 characters
fieldsType
FieldsType is the discriminator for the different fields format and version. There is currently only one possible value: "FieldsV1"

Field specification or configuration

string
<= 1024 characters
fieldsV1
object
Raw

Raw is the underlying serialization of this object.

string format: byte
<= 1024 characters
manager

Manager is an identifier of the workflow managing these fields.

string
<= 1024 characters
operation

Operation is the type of operation which lead to this ManagedFieldsEntry being created. The only valid values for this field are ‘Apply’ and ‘Update’.

string
<= 1024 characters
time
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
name
Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace

Namespace defines the space within each name must be unique. An empty namespace is equivalent to the “default” namespace, but “default” is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.

Must be a DNS_LABEL. Cannot be updated. More info: HTTP://Kubernetes.I/O/docs/user-guide/namespaces +optional.

string
>= 6 characters <= 1024 characters
ownerReferences
List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller. +optional +patchMergeKey=uid +patchStrategy=merge

Owner or responsible party

Array<object>

OwnerReference contains enough information to let you identify an owning object. An owning object must be in the same namespace as the dependent, or be cluster-scoped, so there is no namespace field.

object
apiVersion

API version of the referent.

string
<= 1024 characters
blockOwnerDeletion
If true, AND if the owner has the "foregroundDeletion" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. Defaults to false. To set this field, a user needs "delete" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned. +optional

Blocking or denial configuration

boolean format: boolean
controller
If true, this reference points to the managing controller. +optional

Configuration parameter for controller

boolean format: boolean
kind
Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

Resource type or kind

string
>= 12 characters <= 1024 characters
name
Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
uid
UID of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#uids

Unique identifier for this resource

string format: uuid
>= 36 characters <= 1024 characters
resourceVersion

An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources.

Populated by the system. Read-only. Value must be treated as opaque by clients and . More info: HTTPS://git.K8s.I/O/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency +optional.

string
0 <= 1024 characters
selfLink

SelfLink is a URL representing this object. Populated by the system. Read-only.

DEPRECATED Kubernetes will stop propagating this field in 1.20 release and the field is planned to be removed in 1.21 release. +optional.

string
0 <= 1024 characters
uid

UID is the unique in time and space value for this object. It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations.

Populated by the system. Read-only. More info: HTTP://Kubernetes.I/O/docs/user-guide/identifiers#uids +optional.

string format: uuid
>= 36 characters <= 1024 characters
spec
object
minReadySeconds
Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready) +optional

Security-related configuration

integer format: int32
paused
Indicates that the deployment is paused. +optional

Configuration parameter for paused

boolean format: boolean
progressDeadlineSeconds

The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s.

integer format: int32
replicas
Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1. +optional

Configuration parameter for replicas

integer format: int32
revisionHistoryLimit
The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10. +optional

Historical or audit data

integer format: int32
selector
object
matchExpressions
matchExpressions is a list of label selector requirements. The requirements are ANDed. +optional

Configuration parameter for matchExpressions

Array<object>

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key
key is the label key that the selector applies to. +patchMergeKey=key +patchStrategy=merge

Cryptographic key material

string
>= 7 characters <= 1024 characters
operator

Operator represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

string
<= 1024 characters
values
values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
matchLabels
matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed. +optional

Key-value label for organization

object
strategy
object
rollingUpdate
object
maxSurge
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
maxUnavailable
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
type
Type of deployment. Can be "Recreate" or "RollingUpdate". Default is RollingUpdate. +optional

Type or category classification

string
<= 1024 characters
template
object
metadata
object
annotations
Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations +optional

Additional metadata and notes

object
clusterName
The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request. +optional

Cluster or grouping configuration

string
<= 1024 characters
creationTimestamp
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
deletionGracePeriodSeconds
Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. Only set when deletionTimestamp is also set. May only be shortened. Read-only. +optional

Security-related configuration

string format: int64
<= 1024 characters
deletionTimestamp
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
finalizers
Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed. Finalizers may be processed and removed in any order. Order is NOT enforced because it introduces significant risk of stuck finalizers. finalizers is a shared field, any actor with permission can reorder it. If the finalizer list is processed in order, then this can lead to a situation in which the component responsible for the first finalizer in the list is waiting for a signal (field value, external system, or other) produced by a component responsible for a finalizer later in the list, resulting in a deadlock. Without enforced ordering finalizers are free to order amongst themselves and are not vulnerable to ordering changes in the list. +optional +patchStrategy=merge

Configuration parameter for finalizers

Array<string>
generateName

GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.

If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).

Applied only if Name is not specified. More info: HTTPS://git.K8s.I/O/community/contributors/devel/sig-architecture/api-conventions.md#idempotency +optional.

string
<= 1024 characters
generation
A sequence number representing a specific generation of the desired state. Populated by the system. Read-only. +optional

Configuration parameter for generation

string format: int64
<= 1024 characters
labels
Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels +optional

Key-value labels for organization and selection

object
managedFields

ManagedFields maps workflow-ID and version to the set of fields that are managed by that workflow. This is mostly for internal housekeeping, and users typically shouldn’t need to set or understand this field. A workflow can be the user’s name, a controller’s name, or the name of a specific apply path like “ci-cd”. The set of fields is always in the version that the workflow used when modifying the object.

+optional.

Array<object>

ManagedFieldsEntry is a workflow-ID, a FieldSet and the group version of the resource that the fieldset applies to.

object
apiVersion

APIVersion defines the version of this resource that this field set applies to. The format is “group/version” just like the top-level APIVersion field. It is necessary to track the version of a field set because it cannot be automatically converted.

string
<= 1024 characters
fieldsType
FieldsType is the discriminator for the different fields format and version. There is currently only one possible value: "FieldsV1"

Field specification or configuration

string
<= 1024 characters
fieldsV1
object
Raw

Raw is the underlying serialization of this object.

string format: byte
<= 1024 characters
manager

Manager is an identifier of the workflow managing these fields.

string
<= 1024 characters
operation

Operation is the type of operation which lead to this ManagedFieldsEntry being created. The only valid values for this field are ‘Apply’ and ‘Update’.

string
<= 1024 characters
time
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
name
Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace

Namespace defines the space within each name must be unique. An empty namespace is equivalent to the “default” namespace, but “default” is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.

Must be a DNS_LABEL. Cannot be updated. More info: HTTP://Kubernetes.I/O/docs/user-guide/namespaces +optional.

string
>= 6 characters <= 1024 characters
ownerReferences
List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller. +optional +patchMergeKey=uid +patchStrategy=merge

Owner or responsible party

Array<object>

OwnerReference contains enough information to let you identify an owning object. An owning object must be in the same namespace as the dependent, or be cluster-scoped, so there is no namespace field.

object
apiVersion

API version of the referent.

string
<= 1024 characters
blockOwnerDeletion
If true, AND if the owner has the "foregroundDeletion" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. Defaults to false. To set this field, a user needs "delete" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned. +optional

Blocking or denial configuration

boolean format: boolean
controller
If true, this reference points to the managing controller. +optional

Configuration parameter for controller

boolean format: boolean
kind
Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

Resource type or kind

string
>= 12 characters <= 1024 characters
name
Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
uid
UID of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#uids

Unique identifier for this resource

string format: uuid
>= 36 characters <= 1024 characters
resourceVersion

An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources.

Populated by the system. Read-only. Value must be treated as opaque by clients and . More info: HTTPS://git.K8s.I/O/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency +optional.

string
0 <= 1024 characters
selfLink

SelfLink is a URL representing this object. Populated by the system. Read-only.

DEPRECATED Kubernetes will stop propagating this field in 1.20 release and the field is planned to be removed in 1.21 release. +optional.

string
0 <= 1024 characters
uid

UID is the unique in time and space value for this object. It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations.

Populated by the system. Read-only. More info: HTTP://Kubernetes.I/O/docs/user-guide/identifiers#uids +optional.

string format: uuid
>= 36 characters <= 1024 characters
spec
object
activeDeadlineSeconds
Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer. +optional

Security-related configuration

string format: int64
<= 1024 characters
affinity
object
nodeAffinity
object
preferredDuringSchedulingIgnoredDuringExecution
The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred. +optional

Uniform Resource Identifier

Array<object>

An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. It’s a no-op). A null preferred scheduling term matches no objects (i.e. Is also a no-op).

object
preference
object
matchExpressions
A list of node selector requirements by node's labels. +optional

Configuration parameter for matchExpressions

Array<object>

A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key

The label key that the selector applies to.

string
>= 7 characters <= 1024 characters
operator

Represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

string
<= 1024 characters
values
An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
matchFields
A list of node selector requirements by node's fields. +optional

Configuration parameter for matchFields

Array<object>

A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key

The label key that the selector applies to.

string
>= 7 characters <= 1024 characters
operator

Represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

string
<= 1024 characters
values
An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
weight

Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100.

integer format: int32
requiredDuringSchedulingIgnoredDuringExecution
object
nodeSelectorTerms

Required. A list of node selector terms. The terms are ORed.

Array<object>

A null or empty node selector term matches no objects. The requirements of them are ANDed. The TopologySelectorTerm type implements a subset of the NodeSelectorTerm.

object
matchExpressions
A list of node selector requirements by node's labels. +optional

Configuration parameter for matchExpressions

Array<object>

A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key

The label key that the selector applies to.

string
>= 7 characters <= 1024 characters
operator

Represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

string
<= 1024 characters
values
An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
matchFields
A list of node selector requirements by node's fields. +optional

Configuration parameter for matchFields

Array<object>

A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key

The label key that the selector applies to.

string
>= 7 characters <= 1024 characters
operator

Represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

string
<= 1024 characters
values
An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
podAffinity
object
preferredDuringSchedulingIgnoredDuringExecution
The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred. +optional

Uniform Resource Identifier

Array<object>
The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)
object
podAffinityTerm
object
labelSelector
object
matchExpressions
matchExpressions is a list of label selector requirements. The requirements are ANDed. +optional

Configuration parameter for matchExpressions

Array<object>

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key
key is the label key that the selector applies to. +patchMergeKey=key +patchStrategy=merge

Cryptographic key material

string
>= 7 characters <= 1024 characters
operator

Operator represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

string
<= 1024 characters
values
values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
matchLabels
matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed. +optional

Key-value label for organization

object
namespaces
namespaces specifies which namespaces the labelSelector applies to (matches against); null or empty list means "this pod's namespace" +optional

Human-readable name for the resource

Array<string>
topologyKey

This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.

string
<= 1024 characters
weight

Weight associated with matching the corresponding podAffinityTerm, in the range 1-100.

integer format: int32
requiredDuringSchedulingIgnoredDuringExecution
If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied. +optional

Uniform Resource Identifier

Array<object>
Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running
object
labelSelector
object
matchExpressions
matchExpressions is a list of label selector requirements. The requirements are ANDed. +optional

Configuration parameter for matchExpressions

Array<object>

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key
key is the label key that the selector applies to. +patchMergeKey=key +patchStrategy=merge

Cryptographic key material

string
>= 7 characters <= 1024 characters
operator

Operator represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

string
<= 1024 characters
values
values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
matchLabels
matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed. +optional

Key-value label for organization

object
namespaces
namespaces specifies which namespaces the labelSelector applies to (matches against); null or empty list means "this pod's namespace" +optional

Human-readable name for the resource

Array<string>
topologyKey

This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.

string
<= 1024 characters
podAntiAffinity
object
preferredDuringSchedulingIgnoredDuringExecution
The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred. +optional

Uniform Resource Identifier

Array<object>
The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)
object
podAffinityTerm
object
labelSelector
object
matchExpressions
matchExpressions is a list of label selector requirements. The requirements are ANDed. +optional

Configuration parameter for matchExpressions

Array<object>

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key
key is the label key that the selector applies to. +patchMergeKey=key +patchStrategy=merge

Cryptographic key material

string
>= 7 characters <= 1024 characters
operator

Operator represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

string
<= 1024 characters
values
values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
matchLabels
matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed. +optional

Key-value label for organization

object
namespaces
namespaces specifies which namespaces the labelSelector applies to (matches against); null or empty list means "this pod's namespace" +optional

Human-readable name for the resource

Array<string>
topologyKey

This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.

string
<= 1024 characters
weight

Weight associated with matching the corresponding podAffinityTerm, in the range 1-100.

integer format: int32
requiredDuringSchedulingIgnoredDuringExecution
If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied. +optional

Uniform Resource Identifier

Array<object>
Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running
object
labelSelector
object
matchExpressions
matchExpressions is a list of label selector requirements. The requirements are ANDed. +optional

Configuration parameter for matchExpressions

Array<object>

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

object
key
key is the label key that the selector applies to. +patchMergeKey=key +patchStrategy=merge

Cryptographic key material

string
>= 7 characters <= 1024 characters
operator

Operator represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

string
<= 1024 characters
values
values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch. +optional

Configuration parameter for values

Array<string>
matchLabels
matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed. +optional

Key-value label for organization

object
namespaces
namespaces specifies which namespaces the labelSelector applies to (matches against); null or empty list means "this pod's namespace" +optional

Human-readable name for the resource

Array<string>
topologyKey

This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.

string
<= 1024 characters
automountServiceAccountToken
AutomountServiceAccountToken indicates whether a service account token should be automatically mounted. +optional

Configuration parameter for automountServiceAccountToken

boolean format: boolean
containers
List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated. +patchMergeKey=name +patchStrategy=merge

Configuration parameter for containers

Array<object>

A single application container that you want to run within a pod.

object
args
Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell +optional

Configuration parameter for args

Array<string>
command
Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell +optional

Configuration parameter for command

Array<string>
env
List of environment variables to set in the container. Cannot be updated. +optional +patchMergeKey=name +patchStrategy=merge

Configuration parameter for env

Array<object>

EnvVar represents an environment variable present in a Container.

object
name

Name of the environment variable. Must be a C_IDENTIFIER.

string
>= 6 characters <= 1024 characters
value
Variable references $(VAR_NAME) are expanded using the previous defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "". +optional

Configuration parameter for value

string
>= 3 characters <= 1024 characters
valueFrom
object
configMapKeyRef
object
key

The key to select.

string
>= 7 characters <= 1024 characters
localObjectReference
object
name
Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid? +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
optional
Specify whether the ConfigMap or its key must be defined +optional

Indicates if this field is optional

boolean format: boolean
fieldRef
object
apiVersion
Version of the schema the FieldPath is written in terms of, defaults to "v1". +optional

Version number or identifier

string
<= 1024 characters
fieldPath

Path of the field to select in the specified API version.

string
<= 1024 characters
resourceFieldRef
object
containerName
Container name: required for volumes, optional for env vars +optional

Human-readable name for this resource

string
<= 1024 characters
divisor
object
string

Configuration parameter for string

string
<= 1024 characters
resource
Required: resource to select

Configuration parameter for resource

string
<= 1024 characters
secretKeyRef
object
key

The key of the secret to select from. Must be a valid secret key.

string
>= 7 characters <= 1024 characters
localObjectReference
object
name
Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid? +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
optional
Specify whether the Secret or its key must be defined +optional

Indicates if this field is optional

boolean format: boolean
envFrom
List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated. +optional

Configuration parameter for envFrom

Array<object>
EnvFromSource represents the source of a set of ConfigMaps
object
configMapRef
object
localObjectReference
object
name
Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid? +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
optional
Specify whether the ConfigMap must be defined +optional

Indicates if this field is optional

boolean format: boolean
prefix
An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER. +optional

Configuration parameter for prefix

string
<= 1024 characters
secretRef
object
localObjectReference
object
name
Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid? +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
optional
Specify whether the Secret must be defined +optional

Indicates if this field is optional

boolean format: boolean
image
Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets. +optional

Configuration parameter for image

string
<= 1024 characters
imagePullPolicy
Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images +optional

Configuration parameter for imagePullPolicy

string
<= 1024 characters
lifecycle
object
postStart
object
exec
object
command
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. +optional

Configuration parameter for command

Array<string>
httpGet
object
host
Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. +optional

Hostname or IP address of the target server

string
<= 1024 characters
httpHeaders
Custom headers to set in the request. HTTP allows repeated headers. +optional

Configuration parameter for httpHeaders

Array<object>
HTTPHeader describes a custom header to be used in HTTP probes
object
name
The header field name

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
value
The header field value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
path
Path to access on the HTTP server. +optional

URL path for the endpoint

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
scheme
Scheme to use for connecting to the host. Defaults to HTTP. +optional

Configuration parameter for scheme

string
<= 1024 characters
tcpSocket
object
host
Optional: Host name to connect to, defaults to the pod IP. +optional

Hostname or IP address of the target server

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
preStop
object
exec
object
command
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. +optional

Configuration parameter for command

Array<string>
httpGet
object
host
Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. +optional

Hostname or IP address of the target server

string
<= 1024 characters
httpHeaders
Custom headers to set in the request. HTTP allows repeated headers. +optional

Configuration parameter for httpHeaders

Array<object>
HTTPHeader describes a custom header to be used in HTTP probes
object
name
The header field name

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
value
The header field value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
path
Path to access on the HTTP server. +optional

URL path for the endpoint

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
scheme
Scheme to use for connecting to the host. Defaults to HTTP. +optional

Configuration parameter for scheme

string
<= 1024 characters
tcpSocket
object
host
Optional: Host name to connect to, defaults to the pod IP. +optional

Hostname or IP address of the target server

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
livenessProbe
object
failureThreshold
Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1. +optional

Configuration parameter for failureThreshold

integer format: int32
handler
object
exec
object
command
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. +optional

Configuration parameter for command

Array<string>
httpGet
object
host
Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. +optional

Hostname or IP address of the target server

string
<= 1024 characters
httpHeaders
Custom headers to set in the request. HTTP allows repeated headers. +optional

Configuration parameter for httpHeaders

Array<object>
HTTPHeader describes a custom header to be used in HTTP probes
object
name
The header field name

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
value
The header field value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
path
Path to access on the HTTP server. +optional

URL path for the endpoint

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
scheme
Scheme to use for connecting to the host. Defaults to HTTP. +optional

Configuration parameter for scheme

string
<= 1024 characters
tcpSocket
object
host
Optional: Host name to connect to, defaults to the pod IP. +optional

Hostname or IP address of the target server

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
initialDelaySeconds
Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional

Security-related configuration

integer format: int32
periodSeconds
How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. +optional

Security-related configuration

integer format: int32
successThreshold
Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1. +optional

Configuration parameter for successThreshold

integer format: int32
timeoutSeconds
Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional

Security-related configuration

integer format: int32
name

Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

string
>= 6 characters <= 1024 characters
ports
List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Cannot be updated. +optional +patchMergeKey=containerPort +patchStrategy=merge +listType=map +listMapKey=containerPort +listMapKey=protocol

Network port number

Array<object>

ContainerPort represents a network port in a single container.

object
containerPort

Number of port to expose on the pod’s IP address. This must be a valid port number, 0 < x < 65536.

integer format: int32
hostIP
What host IP to bind the external port to. +optional

Host configuration or identifier

string
<= 1024 characters
hostPort
Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this. +optional

Host configuration or identifier

integer format: int32
name
If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
protocol
Protocol for port. Must be UDP, TCP, or SCTP. Defaults to "TCP". +optional

Configuration parameter for protocol

string
<= 1024 characters
readinessProbe
object
failureThreshold
Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1. +optional

Configuration parameter for failureThreshold

integer format: int32
handler
object
exec
object
command
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. +optional

Configuration parameter for command

Array<string>
httpGet
object
host
Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. +optional

Hostname or IP address of the target server

string
<= 1024 characters
httpHeaders
Custom headers to set in the request. HTTP allows repeated headers. +optional

Configuration parameter for httpHeaders

Array<object>
HTTPHeader describes a custom header to be used in HTTP probes
object
name
The header field name

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
value
The header field value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
path
Path to access on the HTTP server. +optional

URL path for the endpoint

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
scheme
Scheme to use for connecting to the host. Defaults to HTTP. +optional

Configuration parameter for scheme

string
<= 1024 characters
tcpSocket
object
host
Optional: Host name to connect to, defaults to the pod IP. +optional

Hostname or IP address of the target server

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
initialDelaySeconds
Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional

Security-related configuration

integer format: int32
periodSeconds
How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. +optional

Security-related configuration

integer format: int32
successThreshold
Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1. +optional

Configuration parameter for successThreshold

integer format: int32
timeoutSeconds
Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional

Security-related configuration

integer format: int32
resources
object
limits
Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/ +optional

Configuration parameter for limits

object
requests
Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/ +optional

Configuration parameter for requests

object
securityContext
object
allowPrivilegeEscalation
AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN +optional

Configuration parameter for allowPrivilegeEscalation

boolean format: boolean
capabilities
object
add
Added capabilities +optional

Configuration parameter for add

Array<string>
drop
Removed capabilities +optional

Configuration parameter for drop

Array<string>
privileged
Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. +optional

Configuration parameter for privileged

boolean format: boolean
procMount
procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. +optional

Configuration parameter for procMount

string
<= 1024 characters
readOnlyRootFilesystem
Whether this container has a read-only root filesystem. Default is false. +optional

Configuration parameter for readOnlyRootFilesystem

boolean format: boolean
runAsGroup
The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. +optional

Configuration parameter for runAsGroup

string format: int64
<= 1024 characters
runAsNonRoot
Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. +optional

Configuration parameter for runAsNonRoot

boolean format: boolean
runAsUser
The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. +optional

Configuration parameter for runAsUser

string format: int64
<= 1024 characters
seLinuxOptions
object
level
Level is SELinux level label that applies to the container. +optional

Configuration parameter for level

string
<= 1024 characters
role
Role is a SELinux role label that applies to the container. +optional

Configuration parameter for role

string
<= 1024 characters
type
Type is a SELinux type label that applies to the container. +optional

Type or category classification

string
<= 1024 characters
user
User is a SELinux user label that applies to the container. +optional

Configuration parameter for user

string
<= 1024 characters
windowsOptions
object
gmsaCredentialSpec
GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field. This field is alpha-level and is only honored by servers that enable the WindowsGMSA feature flag. +optional

Desired state specification

string
<= 1024 characters
gmsaCredentialSpecName
GMSACredentialSpecName is the name of the GMSA credential spec to use. This field is alpha-level and is only honored by servers that enable the WindowsGMSA feature flag. +optional

Human-readable name for this resource

string
<= 1024 characters
runAsUserName
The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. This field is beta-level and may be disabled with the WindowsRunAsUserName feature flag. +optional

Human-readable name for this resource

string
<= 1024 characters
startupProbe
object
failureThreshold
Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1. +optional

Configuration parameter for failureThreshold

integer format: int32
handler
object
exec
object
command
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. +optional

Configuration parameter for command

Array<string>
httpGet
object
host
Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. +optional

Hostname or IP address of the target server

string
<= 1024 characters
httpHeaders
Custom headers to set in the request. HTTP allows repeated headers. +optional

Configuration parameter for httpHeaders

Array<object>
HTTPHeader describes a custom header to be used in HTTP probes
object
name
The header field name

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
value
The header field value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
path
Path to access on the HTTP server. +optional

URL path for the endpoint

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
scheme
Scheme to use for connecting to the host. Defaults to HTTP. +optional

Configuration parameter for scheme

string
<= 1024 characters
tcpSocket
object
host
Optional: Host name to connect to, defaults to the pod IP. +optional

Hostname or IP address of the target server

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
initialDelaySeconds
Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional

Security-related configuration

integer format: int32
periodSeconds
How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. +optional

Security-related configuration

integer format: int32
successThreshold
Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1. +optional

Configuration parameter for successThreshold

integer format: int32
timeoutSeconds
Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional

Security-related configuration

integer format: int32
stdin
Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false. +optional

Configuration parameter for stdin

boolean format: boolean
stdinOnce
Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false +optional

Configuration parameter for stdinOnce

boolean format: boolean
terminationMessagePath
Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated. +optional

File system or URL path

string
<= 1024 characters
terminationMessagePolicy
Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated. +optional

Configuration parameter for terminationMessagePolicy

string
<= 1024 characters
tty
Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false. +optional

Configuration parameter for tty

boolean format: boolean
volumeDevices
volumeDevices is the list of block devices to be used by the container. This is a beta feature. +patchMergeKey=devicePath +patchStrategy=merge +optional

Configuration parameter for volumeDevices

Array<object>

VolumeDevice describes a mapping of a raw block device within a container.

object
devicePath

DevicePath is the path inside of the container that the device will be mapped to.

string
<= 1024 characters
name
name must match the name of a persistentVolumeClaim in the pod

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
volumeMounts
Pod volumes to mount into the container's filesystem. Cannot be updated. +optional +patchMergeKey=mountPath +patchStrategy=merge

Configuration parameter for volumeMounts

Array<object>

VolumeMount describes a mounting of a Volume within a container.

object
mountPath

Path within the container at which the volume should be mounted. Must not contain ’:’.

string
<= 1024 characters
mountPropagation
mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10. +optional

Configuration parameter for mountPropagation

string
<= 1024 characters
name

This must match the Name of a Volume.

string
>= 6 characters <= 1024 characters
readOnly
Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false. +optional

Configuration parameter for readOnly

boolean format: boolean
subPath
Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root). +optional

File system or URL path

string
<= 1024 characters
subPathExpr
Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive. +optional

File system or URL path

string
<= 1024 characters
workingDir
Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated. +optional

Configuration parameter for workingDir

string
<= 1024 characters
dnsConfig
object
nameservers
A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed. +optional

Human-readable name for the resource

Array<string>
options
A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy. +optional

Configuration parameter for options

Array<object>

PodDNSConfigOption defines DNS resolver OPTIONS of a pod.

object
name

Required.

string
>= 6 characters <= 1024 characters
value
+optional

Configuration parameter for value

string
>= 3 characters <= 1024 characters
searches
A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed. +optional

Configuration parameter for searches

Array<string>
dnsPolicy
Set DNS policy for the pod. Defaults to "ClusterFirst". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'. +optional

Configuration parameter for dnsPolicy

string
<= 1024 characters
enableServiceLinks
EnableServiceLinks indicates whether information about services should be injected into pod's environment variables, matching the syntax of Docker links. Optional: Defaults to true. +optional

Configuration parameter for enableServiceLinks

boolean format: boolean
ephemeralContainers
List of ephemeral containers run in this pod. Ephemeral containers may be run in an existing pod to perform user-initiated actions such as debugging. This list cannot be specified when creating a pod, and it cannot be modified by updating the pod spec. In order to add an ephemeral container to an existing pod, use the pod's ephemeralcontainers subresource. This field is alpha-level and is only honored by servers that enable the EphemeralContainers feature. +optional +patchMergeKey=name +patchStrategy=merge

Configuration parameter for ephemeralContainers

Array<object>

An EphemeralContainer is a container that may be added temporarily to an existing pod for user-initiated activities such as debugging. Ephemeral containers have no resource or scheduling guarantees, and they will not be restarted when they exit or when a pod is removed or restarted. If an ephemeral container causes a pod to exceed its resource allocation, the pod may be evicted. Ephemeral containers may not be added by directly updating the pod spec. They must be added via the pod’s ephemeralcontainers subresource, and they will appear in the pod spec once added. This is an alpha feature enabled by the EphemeralContainers feature flag.

object
ephemeralContainerCommon
object
args
Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell +optional

Configuration parameter for args

Array<string>
command
Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell +optional

Configuration parameter for command

Array<string>
env
List of environment variables to set in the container. Cannot be updated. +optional +patchMergeKey=name +patchStrategy=merge

Configuration parameter for env

Array<object>

EnvVar represents an environment variable present in a Container.

object
name

Name of the environment variable. Must be a C_IDENTIFIER.

string
>= 6 characters <= 1024 characters
value
Variable references $(VAR_NAME) are expanded using the previous defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "". +optional

Configuration parameter for value

string
>= 3 characters <= 1024 characters
valueFrom
object
configMapKeyRef
object
key

The key to select.

string
>= 7 characters <= 1024 characters
localObjectReference
object
name
Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid? +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
optional
Specify whether the ConfigMap or its key must be defined +optional

Indicates if this field is optional

boolean format: boolean
fieldRef
object
apiVersion
Version of the schema the FieldPath is written in terms of, defaults to "v1". +optional

Version number or identifier

string
<= 1024 characters
fieldPath

Path of the field to select in the specified API version.

string
<= 1024 characters
resourceFieldRef
object
containerName
Container name: required for volumes, optional for env vars +optional

Human-readable name for this resource

string
<= 1024 characters
divisor
object
string

Configuration parameter for string

string
<= 1024 characters
resource
Required: resource to select

Configuration parameter for resource

string
<= 1024 characters
secretKeyRef
object
key

The key of the secret to select from. Must be a valid secret key.

string
>= 7 characters <= 1024 characters
localObjectReference
object
name
Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid? +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
optional
Specify whether the Secret or its key must be defined +optional

Indicates if this field is optional

boolean format: boolean
envFrom
List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated. +optional

Configuration parameter for envFrom

Array<object>
EnvFromSource represents the source of a set of ConfigMaps
object
configMapRef
object
localObjectReference
object
name
Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid? +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
optional
Specify whether the ConfigMap must be defined +optional

Indicates if this field is optional

boolean format: boolean
prefix
An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER. +optional

Configuration parameter for prefix

string
<= 1024 characters
secretRef
object
localObjectReference
object
name
Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid? +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
optional
Specify whether the Secret must be defined +optional

Indicates if this field is optional

boolean format: boolean
image
Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images

Configuration parameter for image

string
<= 1024 characters
imagePullPolicy
Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images +optional

Configuration parameter for imagePullPolicy

string
<= 1024 characters
lifecycle
object
postStart
object
exec
object
command
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. +optional

Configuration parameter for command

Array<string>
httpGet
object
host
Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. +optional

Hostname or IP address of the target server

string
<= 1024 characters
httpHeaders
Custom headers to set in the request. HTTP allows repeated headers. +optional

Configuration parameter for httpHeaders

Array<object>
HTTPHeader describes a custom header to be used in HTTP probes
object
name
The header field name

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
value
The header field value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
path
Path to access on the HTTP server. +optional

URL path for the endpoint

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
scheme
Scheme to use for connecting to the host. Defaults to HTTP. +optional

Configuration parameter for scheme

string
<= 1024 characters
tcpSocket
object
host
Optional: Host name to connect to, defaults to the pod IP. +optional

Hostname or IP address of the target server

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
preStop
object
exec
object
command
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. +optional

Configuration parameter for command

Array<string>
httpGet
object
host
Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. +optional

Hostname or IP address of the target server

string
<= 1024 characters
httpHeaders
Custom headers to set in the request. HTTP allows repeated headers. +optional

Configuration parameter for httpHeaders

Array<object>
HTTPHeader describes a custom header to be used in HTTP probes
object
name
The header field name

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
value
The header field value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
path
Path to access on the HTTP server. +optional

URL path for the endpoint

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
scheme
Scheme to use for connecting to the host. Defaults to HTTP. +optional

Configuration parameter for scheme

string
<= 1024 characters
tcpSocket
object
host
Optional: Host name to connect to, defaults to the pod IP. +optional

Hostname or IP address of the target server

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
livenessProbe
object
failureThreshold
Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1. +optional

Configuration parameter for failureThreshold

integer format: int32
handler
object
exec
object
command
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. +optional

Configuration parameter for command

Array<string>
httpGet
object
host
Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. +optional

Hostname or IP address of the target server

string
<= 1024 characters
httpHeaders
Custom headers to set in the request. HTTP allows repeated headers. +optional

Configuration parameter for httpHeaders

Array<object>
HTTPHeader describes a custom header to be used in HTTP probes
object
name
The header field name

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
value
The header field value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
path
Path to access on the HTTP server. +optional

URL path for the endpoint

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
scheme
Scheme to use for connecting to the host. Defaults to HTTP. +optional

Configuration parameter for scheme

string
<= 1024 characters
tcpSocket
object
host
Optional: Host name to connect to, defaults to the pod IP. +optional

Hostname or IP address of the target server

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
initialDelaySeconds
Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional

Security-related configuration

integer format: int32
periodSeconds
How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. +optional

Security-related configuration

integer format: int32
successThreshold
Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1. +optional

Configuration parameter for successThreshold

integer format: int32
timeoutSeconds
Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional

Security-related configuration

integer format: int32
name

Name of the ephemeral container specified as a DNS_LABEL. This name must be unique among all containers, init containers and ephemeral containers.

string
>= 6 characters <= 1024 characters
ports

Ports are not allowed for ephemeral containers.

Array<object>

ContainerPort represents a network port in a single container.

object
containerPort

Number of port to expose on the pod’s IP address. This must be a valid port number, 0 < x < 65536.

integer format: int32
hostIP
What host IP to bind the external port to. +optional

Host configuration or identifier

string
<= 1024 characters
hostPort
Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this. +optional

Host configuration or identifier

integer format: int32
name
If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
protocol
Protocol for port. Must be UDP, TCP, or SCTP. Defaults to "TCP". +optional

Configuration parameter for protocol

string
<= 1024 characters
readinessProbe
object
failureThreshold
Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1. +optional

Configuration parameter for failureThreshold

integer format: int32
handler
object
exec
object
command
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. +optional

Configuration parameter for command

Array<string>
httpGet
object
host
Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. +optional

Hostname or IP address of the target server

string
<= 1024 characters
httpHeaders
Custom headers to set in the request. HTTP allows repeated headers. +optional

Configuration parameter for httpHeaders

Array<object>
HTTPHeader describes a custom header to be used in HTTP probes
object
name
The header field name

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
value
The header field value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
path
Path to access on the HTTP server. +optional

URL path for the endpoint

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
scheme
Scheme to use for connecting to the host. Defaults to HTTP. +optional

Configuration parameter for scheme

string
<= 1024 characters
tcpSocket
object
host
Optional: Host name to connect to, defaults to the pod IP. +optional

Hostname or IP address of the target server

string
<= 1024 characters
port
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
initialDelaySeconds
Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional

Security-related configuration

integer format: int32
periodSeconds
How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. +optional

Security-related configuration

integer format: int32
successThreshold
Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1. +optional

Configuration parameter for successThreshold

integer format: int32
timeoutSeconds
Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional

Security-related configuration

integer format: int32
resources
object
limits
Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/ +optional

Configuration parameter for limits

object
requests
Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/ +optional

Configuration parameter for requests

object
securityContext
object
allowPrivilegeEscalation
AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN +optional

Configuration parameter for allowPrivilegeEscalation

boolean format: boolean
capabilities
object
add
Added capabilities +optional

Configuration parameter for add

Array<string>
drop
Removed capabilities +optional

Configuration parameter for drop

Array<string>
privileged
Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. +optional

Configuration parameter for privileged

boolean format: boolean
procMount
procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. +optional

Configuration parameter for procMount

string
<= 1024 characters
readOnlyRootFilesystem
Whether this container has a read-only root filesystem. Default is false. +optional

Configuration parameter for readOnlyRootFilesystem

boolean format: boolean
runAsGroup
The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. +optional

Configuration parameter for runAsGroup

string format: int64
<= 1024 characters
runAsNonRoot
Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. +optional

Configuration parameter for runAsNonRoot

boolean format: boolean
runAsUser
The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. +optional

Configuration parameter for runAsUser

string format: int64
<= 1024 characters
seLinuxOptions
object
level
Level is SELinux level label that applies to the container. +optional

Configuration parameter for level

string
<= 1024 characters
role
Role is a SELinux role label that applies to the container. +optional

Configuration parameter for role

string
<= 1024 characters
type
Type is a SELinux type label that applies to the container. +optional

Type or category classification

string
<= 1024 characters
user
User is a SELinux user label that applies to the container. +optional

Configuration parameter for user

string
<= 1024 characters
windowsOptions
object
gmsaCredentialSpec
GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field. This field is alpha-level and is only honored by servers that enable the WindowsGMSA feature flag. +optional

Desired state specification

string
<= 1024 characters
gmsaCredentialSpecName
GMSACredentialSpecName is the name of the GMSA credential spec to use. This field is alpha-level and is only honored by servers that enable the WindowsGMSA feature flag. +optional

Human-readable name for this resource

string
<= 1024 characters
runAsUserName
The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. This field is beta-level and may be disabled with the WindowsRunAsUserName feature flag. +optional

Human-readable name for this resource

string
<= 1024 characters
startupProbe
object
failureThreshold
Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1. +optional

Configuration parameter for failureThreshold

integer format: int32
handler
object
exec
object
command
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. +optional

Configuration parameter for command

Array<string>
httpGet
object
host
Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. +optional

Hostname or IP address of the target server

string
<= 1024 characters
httpHeaders
Custom headers to set in the request. HTTP allows repeated headers. +optional

Configuration parameter for httpHeaders

Array<object>
HTTPHeader describes a custom header to be used in HTTP probes
object
name
The header field name

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
value
The header field value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
path
[...]
